///////////////////////////////////////////////////////////////////////////////
//
//            (C) Copyright 2009-2010 OSR Open Systems Resources, Inc.
//            All Rights Reserved
//
//    This work is distributed under the OSR Non-Commercial Software License which is provided
//    at "http://www.osronline.com/page.cfm?name=NonCommLicense" in the hope that it will be
//    enlightening, but WITHOUT ANY WARRANTY; without even the implied warranty of MECHANTABILITY
//    or FITNESS FOR A PARTICULAR PURPOSE.
//
//            OSR Open Systems Resources, Inc.
//            105 Route 101A Suite 19
//            Amherst, NH 03031  (603) 595-6500 FAX: (603) 595-6503

//
//    MODULE:
//
//        $File: //depot/tools/UMERESOURCES/UmEResourceDll/UmEResourceDll.cpp $
//
//    ABSTRACT:
//
//     Defines the initialization routines for the DLL.
//
//    AUTHOR:
//
//        OSR Open Systems Resources, Inc.
// 
//    REVISION:   
//
//        $Revision: #1 $
//
//
///////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "UmEResourceDll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#if 1
//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CUmEResourceDllApp

BEGIN_MESSAGE_MAP(CUmEResourceDllApp, CWinApp)
END_MESSAGE_MAP()


// CUmEResourceDllApp construction

CUmEResourceDllApp::CUmEResourceDllApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CUmEResourceDllApp object

CUmEResourceDllApp theApp;


// CUmEResourceDllApp initialization

BOOL CUmEResourceDllApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}
#else

///////////////////////////////////////////////////////////////////////////////
//
//  DllMain
//
//      This function is called when processes or threads attach or detach
//      from the DLL.
//
//  INPUTS:
//
//      hModule - handle of the module attaching.
//      ul_reason_for_call - why DLL is being called.
//      lpReserved - reserved.
//
//  OUTPUTS:
//
//      None.
//
//  RETURNS:
//
//      TRUE, if operation successful.
//
//  NOTES:
//
//
///////////////////////////////////////////////////////////////////////////////
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
 
    switch (ul_reason_for_call) {

		case DLL_PROCESS_ATTACH:

			if(!AfxWinInit(::GetModuleHandle(NULL), NULL, NULL, 0)) {
				return FALSE;
			}

		   //
            // Just drop through a new process/thread is attaching.
            //
        case DLL_THREAD_ATTACH:
 
            break; 
 
        case DLL_THREAD_DETACH: 
            // 
            // Release the allocated memory for this thread.
            //
            break; 
 
		case DLL_PROCESS_DETACH:  {
            //
            // Release the TLS index.
            //
			}
            break; 

        default:
            break;
 
    }

    return TRUE;
}
#endif